# Matrix Modbot

Matrix Modbot is a bot for Matrix used to automatically moderate Matrix rooms. 

## Who is this bot for?

The bot is orientated towards admins of large Matrix rooms that are public and require constant moderation. With this bot, simple jobs such as swear filtering and spam prevention could be accomplished without intervention of human moderators. 

## How to run?

**Using Docker:**
A minimal Docker image containing the compiled binary is published on [Docker Hub](https://hub.docker.com/r/davidlocalhost/matrix-modbot). Note that this image is automatically pushed using a CI/CD Pipeline for every commit made to the main branch. Expect there to be bugs and breaking changes. 
`sudo docker run -v /local/path/to/config.ini:/config.ini -t matrix-modbot:latest`

**Using Cargo:**
```
cargo build --release
cargo run /path/to/config.ini
``` 

## Features

- Easy to configure
- Configurable swear detection
- Spam detection
- Anti-Caps
- Reputation system
  - All members of a room have reputation points, they are deducted when spam/swear/caps are detected
  - Automatically kicks a member if reputation is too low
  - Members can award each other with maximum 1 reputation point every 24hr

### Commands
For awarding someone reputation: 
- "!modbot award @user:matrix.org"

To get own reputation:
- "!modbot reputation"
